# -*- coding: utf-8 -*-

from setuptools import *
import numpy
import os
import sys

version = ("PYTHON2",None)
if sys.version_info.major==3:
    version = ("PYTHON3",None)
    
numpy_include = numpy.get_include()


pthread_include = 'D:/Personnel/library/pthread/pthreads-w32-2-9-1-release/Pre-built.2/include'
pthread_lib = 'D:/Personnel/library/pthread/pthreads-w32-2-9-1-release/Pre-built.2/lib/x64'
opencl_include="D:/Programmes/NVIDIA GPU Computing Toolkit/CUDA/v7.5/include"
opencl_library="D:/Programmes/NVIDIA GPU Computing Toolkit/CUDA/v7.5/lib/x64"


module_pypoissonMG = Extension(name="poisson.pypoissonMG",
    sources=['src/poissonMG.c','src/pypoissonMG.c'],
    include_dirs=[numpy_include,pthread_include,opencl_include],
    library_dirs=[pthread_lib,opencl_library],
    libraries=['OpenCL','pthreadVC2'],
    define_macros=[('OPENCL',None),version,('_TIMESPEC_DEFINED',None)])
# enlever OPENCL pour compiler sans OpenCL
# placer pthreadVC2.dll dans le build
setup(name="poisson",
    version = "0.2",
    description= "Equation de Poisson",
    author = "Frederic Legrand",
    author_email = "fredlegr@club-internet.fr",
    url="http://www.f-legrand.fr",
    packages=['poisson'],
    license="CeCILL",
    ext_modules=[module_pypoissonMG ])

