# -*- coding: utf-8 -*-
from distutils.core import setup, Extension
from distutils import ccompiler
import numpy
import os
numpy_include = numpy.get_include()

opencl_include = "/home/fred/NVIDIA_GPU_Computing_SDK/OpenCL/common/inc"
# à enlever pour compiler sans OpenCL


module_pypoissonMG = Extension(name="poisson.pypoissonMG",
    sources=['src/poissonMG.c','src/pypoissonMG.c'],
    include_dirs=[numpy_include,opencl_include],
    libraries=['OpenCL','m','pthread'],define_macros=[('OPENCL',None)])

# enlever define_macros pour compiler sans OpenCL

setup(name="poisson",
    version = "0.1",
    description= "Equation de Poisson",
    author = "Frederic Legrand",
    author_email = "fredlegr@club-internet.fr",
    url="www.f-legrand.fr/scidoc",
    packages=['poisson'],
    ext_modules=[module_pypoissonMG ])

