
from matplotlib.pyplot import *
import math
import numpy
import poisson.main
            

n=7
p=4
levels = n-p+1
bobine=poisson.main.PoissonAxialVect(p+1,p,levels,1.0,1.0,x0=-0.5,y0=-0.5,restriction=20)
bobine.laplacien()
bobine.dirichlet_borders(0.0)
            

bobine.source_rect(16,4,1,1,-1.0)
            

result=bobine.opencl_iterations_norm(20,50,omega=1.95)
bobine.init_array()
result1 = bobine.multigrid_Vcycles_norm(1,4,100,2,1,20)

figure(figsize=(8,5))
plot(result[0],result[1]) 
plot(result1[0],result1[1]) 
xlabel('niter')  
ylabel('norm')
grid() 
            

Atheta=bobine.get_array(symetry=-1)
Br=-bobine.get_derivZ(symetry=-1)
Bz=bobine.get_derivRUR(symetry=1)
            

figure(figsize=(8,8))
extent=bobine.get_extent()
contour(Atheta,20,extent=bobine.extent,color='r')
imshow(~bobine.get_mask(symetry=1),extent=extent,alpha=0.5, cmap=cm.gray)
xlabel('z')
ylabel('r')
grid()
            
bobine.close()            
            
show()