import poisson.main
from matplotlib.pyplot import *
import math

n=7
laplace = poisson.main.Poisson(n,n,1,1)
laplace.laplacien()
laplace.dirichlet_borders(0.0)
p=n-4 # maille reduite 4x4
conducteur = poisson.main.Polygon(laplace,p,[7,7])
s=1000 
conducteur.add_boundary([0,1],2,poisson.main.LIMIT_SOURCE,s,0,0,0)
conducteur.add_boundary([1,0],2,poisson.main.LIMIT_SOURCE,s,0,0,0)
conducteur.add_boundary([0,-1],2,poisson.main.LIMIT_SOURCE,s,0,0,0)
conducteur.add_boundary([-1,0],2,poisson.main.LIMIT_SOURCE,s,0,0,0)
conducteur.apply_limit()
laplace.set_opencl_platform_device(0,0)
result=laplace.opencl_iterations_norm(2000,30)
U=laplace.get_array()
Ex=laplace.get_derivX()
Ey=laplace.get_derivY()
laplace.close()
figure(figsize=(8,8))
contour(U,30,extent=(-1,1,-1,1))
imshow(~laplace.mask,extent=(-1,1,-1,1),alpha=0.5, cmap=cm.gray)
xlabel('x')
ylabel('y')
            

figure()
plot(Ex[math.pow(2,n-1),:])
xlabel('x')
ylabel('Ex') 
show()
