# -*- coding: utf-8 -*-
import poisson.main
from matplotlib.pyplot import *
import math
import time

n=8
laplace = poisson.main.Poisson(n,n,1,1,-0.5,-0.5)
laplace.set_opencl_platform_device(0,0)
laplace.laplacien()
laplace.neumann_borders(0,0,0,0,0)
#laplace.dirichlet_borders(0.0)
#objets definis sur une maille de 2 puissance 4
p = n-4
plaque1 = poisson.main.Polygon(laplace,p,[7,6])
plaque1.add_boundary([0,1],4,poisson.main.LIMIT_DIRICHLET,0,1,0,0)
plaque2 = poisson.main.Polygon(laplace,p,[8,6])
plaque2.add_boundary([0,1],4,poisson.main.LIMIT_DIRICHLET,0,-1,0,0)
plaque1.apply_limit()
plaque2.apply_limit()
t = time.clock()
#result=laplace.iterations_norm(1000,20,threads=1,omega=1.9)

result=laplace.opencl_iterations_norm(1000,20,omega=1.90)
print("durée : %f"%(time.clock()-t))
figure()
plot(result[0],result[1])
xlabel("niter")
ylabel("norm")
U=laplace.get_array()
Ex=-laplace.get_derivX()
Ey=-laplace.get_derivY()
x=laplace.get_x()
y=laplace.get_y()
figure()
plot(x,U[math.pow(2,n)/2,:])
plot(x,U[1,:])
xlabel('x')
ylabel('Ex')
figure()
contour(U,20,extent=laplace.extent)
xlabel('x')
ylabel('y')
imshow(~laplace.mask,extent=laplace.extent,alpha=0.5,cmap=cm.gray)
laplace.close()
show()
