# -*- coding: utf-8 -*-
from pylab import *
import numpy
import poisson.main
import time

levels = 6
laplace = poisson.main.Poisson(4,4,levels,1.0,1.0,restriction=20)
symetry=0
laplace.laplacien()
laplace.dirichlet_borders(0.0)
#laplace.neumann_borders(0,0,0,0,0)
#laplace.source_rect(8,8,2,1,1.0)
laplace.dirichlet_polygon(5,5,[1,0],[0,1],1.0)
#laplace.source_rect(10,10,1,1,100)
#laplace.dirichlet_polygon(10,5,[0],[1],1,1.0)
#laplace.neumann_polygon(4,6,[0,4,0,-4],[2,0,-2,0],[0,0,0,0],[0,0,0,0],0.0)
t = time.clock()
#result = laplace.multigrid_iterations_norm(1,5,[2,2,2,2,50,1,1,1,1],30)
result = laplace.multigrid_Vcycles_norm(1,5,50,2,1,30)
print("durée : %f"%(time.clock()-t))
V1 = laplace.get_array(symetry=symetry)
E1x = laplace.get_derivX()
mask = laplace.get_mask(symetry=symetry)
extent = laplace.get_extent(symetry=symetry)

laplace.init_array()
t = time.clock()
omega = laplace.get_optimal_omega()
print(omega)
result2 = laplace.opencl_iterations_norm(10,50,omega=omega)
print("durée : %f"%(time.clock()-t))
V2 = laplace.get_array(symetry=symetry)

laplace.init_array()
t = time.clock()
result3 = laplace.multigrid_full_norm(5,levels,50,1,1)
print("durée : %f"%(time.clock()-t))
V3 = laplace.get_array(symetry=symetry)

laplace.close()
figure(figsize=(10,5))
plot(result[0],result[1],'r')
plot(result2[0],result2[1],'b')
plot(result3[0],result3[1],'g')
xlabel('niter')
ylabel('norm')

grid()
figure(figsize=(8,8))
contour(V1,40,extent=extent)
imshow(~mask,extent=extent,alpha=0.5, cmap=cm.gray)
figure(figsize=(8,8))
contour(V2,40,extent=extent)
imshow(~mask,extent=extent,alpha=0.5, cmap=cm.gray)
figure(figsize=(8,8))
contour(V3,40,extent=extent)
imshow(~mask,extent=extent,alpha=0.5, cmap=cm.gray)
show()

