import poisson.main
import pylab
import math

n=7
laplace = poisson.main.PoissonAxial(n,n,1.0,1.0)
laplace.laplacien()
laplace.neumann_borders(0,0,0,0,0)
p=n-4 # maille reduite 16x16
bord = poisson.main.Polygon(laplace,p,[0,16])
bord.add_boundary([1,0],16,poisson.main.LIMIT_DIRICHLET,0,1,0,0)
bord.apply_limit()

laplace.source_rect(p,[8,4],[2,2],10.0)
plaque = poisson.main.Polygon(laplace,p,[2,7])
a1=5
plaque.add_boundary([1,0],12,poisson.main.LIMIT_INTERFACE,0,0,a1,1)
plaque.add_boundary([0,1],2,poisson.main.LIMIT_INTERFACE,0,0,a1,1)
plaque.add_boundary([-1,0],12,poisson.main.LIMIT_INTERFACE,0,0,a1,1)
plaque.add_boundary([0,-1],2,poisson.main.LIMIT_INTERFACE,0,0,a1,1)
plaque.apply_limit()
result=laplace.opencl_iterations_norm(1000,40)
U=laplace.get_array()
print(U)
laplace.close()
pylab.figure()
pylab.plot(result[0],result[1])
pylab.xlabel('niter')
pylab.ylabel('norm')
pylab.figure(figsize=(8,8))
cont=pylab.contour(U,20,extent=(-1,1,-1,1))
pylab.axis([-1,1,-1,1])
pylab.imshow(~laplace.mask,extent=(-1,1,-1,1),alpha=0.5,interpolation='nearest', cmap=pylab.cm.gray)
pylab.show()


    
