
from matplotlib.pyplot import *
import math
import numpy
import poisson.main
            

n=7
p=4
levels = n-p+1
laplace = poisson.main.PoissonAxial(p+1,p,levels,1.0,1.0,x0=-0.5,y0=-0.5)
laplace.laplacien()
            

V1 = -1.0
V2 = 0.0
V3 = 5.0
rayon = 5
#laplace.dirichlet_borders(0.0)
laplace.neumann_borders(0.0,0.0,0.0,0.0,0.0)
laplace.dirichlet_polygon(0,0,[0],[16],V1)
laplace.dirichlet_polygon(16,rayon,[0],[16-rayon],V2)
laplace.dirichlet_polygon(32,0,[0],[16],V3)


#result=laplace.opencl_iterations_norm(20,50,omega=1.9)
result = laplace.multigrid_Vcycles_norm(1,4,100,2,1,20)
#laplace.fullmultigrid(5,levels,100,2,2)

figure(figsize=(10,6))
plot(result[0],result[1]) 
xlabel('niter')  
ylabel('norm')
grid() 
            

V = laplace.get_array(symetry=1)
Er = -laplace.get_derivR(symetry=-1)
Ez = -laplace.get_derivZ(symetry=1)
z = laplace.get_z()
r = laplace.get_r(symetry=1) 
            

figure(figsize=(8,8))
extent = laplace.get_extent()
contour(V,40,extent=laplace.extent,color='r')
imshow(~laplace.get_mask(symetry=True),extent=extent,alpha=0.5, cmap=cm.gray)
xlabel('z')
ylabel('r')
grid()
            

figure(figsize=(10,5))
plot(z,Ez[128,:])
xlabel('z')
ylabel('Ez')
grid()
            

figure(figsize=(10,5))
plot(z,Ez[128+128*0.6,:])
xlabel('z')
ylabel('Ez')
grid()
            

figure(figsize=(10,5))
plot(r,Er[:,126])
xlabel('r')
ylabel('Er')
grid()
            

laplace.close()
             

show()
             
