# -*- coding: utf-8 -*-
"""
Created on Thu Dec 26 22:04:17 2013

@author: fred
"""

import poisson.main
from matplotlib.pyplot import *
import math
import numpy

n=7
laplace=poisson.main.PoissonAxial(n+1,n,2.0,1.0,x0=-1.0,y0=0.0)
laplace.laplacien()
laplace.dirichlet_borders(0.0)
#laplace.neumann_borders(0,0,0,0,0)
p=n-4 # maille reduite 32x16
re = 3
electrode1 = poisson.main.Polygon(laplace,p,[5,re])
electrode1.add_boundary([1,0],10,poisson.main.LIMIT_DIRICHLET,0,-1,0,0)
electrode2 = poisson.main.Polygon(laplace,p,[18,re])
electrode2.add_boundary([1,0],10,poisson.main.LIMIT_DIRICHLET,0,1,0,0)
electrode1.apply_limit()
electrode2.apply_limit()
result=laplace.iterations_norm(20,50,omega=1.9)
U=laplace.get_array()
Ez=-laplace.get_derivZ()
Er=-laplace.get_derivR()
z=laplace.get_z()
r=laplace.get_r()
figure(figsize=(8,4))
plot(result[0],result[1])
xlabel('niter')  
ylabel('norm')
figure()
contour(U,20,extent=laplace.extent)
xlabel('x')
ylabel('y')
imshow(~laplace.mask,extent=laplace.extent,alpha=0.5,cmap=cm.gray)
figure(figsize=(16,8))
plot(z,Ez[0,:])

numpy.savetxt("lentilleElectrostat-Ez.txt",-laplace.get_derivX(symetry=1))
numpy.savetxt("lentilleElectrostat-Er.txt",-laplace.get_derivY(symetry=-1))
numpy.savetxt("lentilleElectrostat-z.txt",laplace.get_z())
numpy.savetxt("lentilleElectrostat-r.txt",laplace.get_r(symetry=1))
laplace.close()
show()