# -*- coding: utf-8 -*-
"""
Created on Thu Dec 26 20:36:07 2013

@author: fred
"""

from matplotlib.pyplot import *
import math
import numpy
from scipy.interpolate import RectBivariateSpline
from scipy.integrate import odeint

Ez = numpy.loadtxt("anneauCharge-Ez.txt")
Er = numpy.loadtxt("anneauCharge-Er.txt")
z =  numpy.loadtxt("anneauCharge-z.txt")
r =  numpy.loadtxt("anneauCharge-r.txt")
f_Ez=RectBivariateSpline(z,r,Ez.transpose())
f_Er=RectBivariateSpline(z,r,Er.transpose())
plot(f_Ez(z,0.0))
plot(f_Er(z,0.0))
figure(figsize=(8,8))
streamplot(z,r,Ez,Er,density=3)
def equation_ligne(y,t):
    ez = f_Ez(y[0],y[1])
    er = f_Er(y[0],y[1])
    ez=ez[0][0]
    er=er[0][0]
    e = math.sqrt(ez*ez+er*er)
    return [ez/e,er/e]
def ligne(y0,tmax):
    te=0.01
    t=numpy.arange(0.0,tmax,te)
    atol=1e-5
    rtol=1e-5
    y = odeint(equation_ligne,y0,t,rtol=rtol,atol=atol)
    yt = y.transpose()
    zl = yt[0]
    rl = yt[1]
    plot(zl,rl,'r')
#for r0 in numpy.arange(-0.8,0.8,0.1):
#    ligne([-1.0,r0],1.0)
def equation_mvt(y,t):
    ez = f_Ez(y[0],y[1])
    er = f_Er(y[0],y[1])
    return[y[2],y[3],ez,er]
def trajectoire(y0,tmax):
    te=0.01
    t=numpy.arange(0.0,tmax,te)
    atol=1e-5
    rtol=1e-5
    y = odeint(equation_mvt,y0,t,rtol=rtol,atol=atol)
    yt = y.transpose()
    zl = yt[0]
    rl = yt[1]
    plot(zl,rl,'r')
vz0 = 0.0
for r0 in numpy.arange(-0.1,0.1,0.02):
    trajectoire([-1.0,r0,vz0,0.0],100.0)
    
show()

