# -*- coding: utf-8 -*-
"""
Created on Thu Dec 26 20:36:07 2013

@author: fred
"""

from matplotlib.pyplot import *
import math
import numpy
from scipy.interpolate import RectBivariateSpline
from scipy.integrate import odeint

Ez = numpy.loadtxt("lentilleElectrostat-Ez.txt")
Er = numpy.loadtxt("lentilleElectrostat-Er.txt")
z =  numpy.loadtxt("lentilleElectrostat-z.txt")
r =  numpy.loadtxt("lentilleElectrostat-r.txt")
f_Ez=RectBivariateSpline(z,r,Ez.transpose())
f_Er=RectBivariateSpline(z,r,Er.transpose())
plot(z,f_Ez(z,0.0))
plot(z,f_Er(z,0.0))
figure(figsize=(8,8))
streamplot(z,r,Ez,Er,density=3)
def equation_mvt(y,t):
    ez = f_Ez(y[0],y[1])
    er = f_Er(y[0],y[1])
    return[y[2],y[3],-ez,-er]
def trajectoire(y0,tmax):
    te=0.01
    t=numpy.arange(0.0,tmax,te)
    atol=1e-5
    rtol=1e-5
    y = odeint(equation_mvt,y0,t,rtol=rtol,atol=atol)
    yt = y.transpose()
    zl = yt[0]
    rl = yt[1]
    plot(zl,rl,'r')
vz0 = 0.5
for r0 in numpy.arange(-0.1,0.1,0.02):
    trajectoire([-0.3,r0,vz0,0.0],1.5)
    
show()

